/* =============================================================================
 *
 *  Description: This is a C++ implementation for Thread ADI_TTCP_ThreadType
 *
 * -----------------------------------------------------------------------------
 *  Comments:
 *
 * ===========================================================================*/

#include "ADI_TTCP_ThreadType.h"
#include <new>

/******************************************************************************
 *  ADI_TTCP_ThreadType Run Function (ADI_TTCP_ThreadType's main{})
 */
 
void
ADI_TTCP_ThreadType::Run()
{
    // TODO - Put the thread's "main" Initialization HERE
/*
    while (1)
    {
        // TODO - Put the thread's "main" body HERE

        // Use a "break" instruction to exit the "while (1)" loop
    }
*/
    // call the function in ADI-TTCP common code that actually does the work
    (m_pthread->thread_function)(m_pthread->arg); // added JW

    // TODO - Put the thread's exit from "main" HERE
	// A thread is automatically Destroyed when it exits its run function
}

/******************************************************************************
 *  ADI_TTCP_ThreadType Error Handler
 */
 
int
ADI_TTCP_ThreadType::ErrorHandler()
{
    /* TODO - Put this thread's error handling code HERE */

    /* The default ErrorHandler (called below)  raises
     * a kernel panic and stops the system */
    return (VDK::Thread::ErrorHandler());
}

/******************************************************************************
 *  ADI_TTCP_ThreadType Constructor
 */
 
ADI_TTCP_ThreadType::ADI_TTCP_ThreadType(VDK::Thread::ThreadCreationBlock &tcb)
    : VDK::Thread(tcb)
{
    /* This routine does NOT run in new thread's context.  Any non-static thread
     *   initialization should be performed at the beginning of "Run()."
     */

    // TODO - Put code to be executed when this thread has just been created HERE
	m_pthread = /*(ThreadCtrlBlock*)*/(ThCB*)(tcb.user_data_ptr); // added JW
}

/******************************************************************************
 *  ADI_TTCP_ThreadType Destructor
 */
 
ADI_TTCP_ThreadType::~ADI_TTCP_ThreadType()
{
    /* This routine does NOT run in the thread's context.  Any VDK API calls
     *   should be performed at the end of "Run()."
     */

    // TODO - Put code to be executed just before this thread is destroyed HERE

}

/******************************************************************************
 *  ADI_TTCP_ThreadType Externally Accessible, Pre-Constructor Create Function
 */
 
VDK::Thread*
ADI_TTCP_ThreadType::Create(VDK::Thread::ThreadCreationBlock &tcb)
{
    /* This routine does NOT run in new thread's context.  Any non-static thread
     *   initialization should be performed at the beginning of "Run()."
     */

    	return new (tcb) ADI_TTCP_ThreadType(tcb);
}

/* ========================================================================== */
